SystemOrganization addCategory: #'Mustache-Seaside-Core'!

Object subclass: #WAMustacheSectionTag
	instanceVariableNames: 'inverted html name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!WAMustacheSectionTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:32'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html
	^ html! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html: anObject
	html := anObject! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:43'!
initialize
inverted:=false! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
inverted
inverted:=true! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:39'!
name:aSectionName
name:=aSectionName! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
with:aBlock
self html  flush.
self html document nextPutAll: (inverted ifFalse:['{{#',name,'}}'] ifTrue:['{{^',name,'}}']).
self html  flush.
aBlock value.
self html  flush.
self html document nextPutAll: '{{/',name,'}}'.! !

Object subclass: #WAMustacheTag
	instanceVariableNames: 'mustacheInstance template html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!WAMustacheTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:03'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 15:42'!
InvertedSection
^ (WAMustacheSectionTag on:html) inverted! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:33'!
basePath: aCompletePath
mustacheInstance ifNil:[mustacheInstance:=Mustache instanceFromFolder:aCompletePath]
! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 2/5/2013 18:15'!
html
^html! !

!WAMustacheTag methodsFor: 'private' stamp: 'JesusMari 12/5/2012 15:41'!
html: aCanvas
html:=aCanvas! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:13'!
includePartial:aPartialName
self html flush.
self html document nextPutAll: '{{>',aPartialName,'}}'! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 15:38'!
section
^ WAMustacheSectionTag on:html! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 2/5/2013 18:07'!
template
^template! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 12/5/2012 15:24'!
template:aTemplate
template:=aTemplate! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:29'!
template:aTemplate view:aView
self template:aTemplate.
self view:aView.
! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
unescapedVariable:aName

^'{{&',aName,'}}'! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
variable:aName
^'{{',aName,'}}'! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 16:27'!
view: aView
(template isKindOf:String) ifTrue:[
	mustacheInstance renderTemplateAt: template view:aView on:html.
	].
(template class superclass = MustacheTemplate class)  ifTrue:[
	Mustache toHtml: template view:aView on:html.
	]! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 22:24'!
with: aBlock
self html flush.
self html document nextPutAll:'<script id="'.
self html document nextPutAll: self template.
self html document nextPutAll:'" type="text/x-jquery-tmpl">'.
aBlock value.
self html document nextPutAll:'</script>'.
self html flush.! !

MustacheTemplate subclass: #MuSTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

MuSTemplate class
	instanceVariableNames: 'instance'!

MuSTemplate class
	instanceVariableNames: 'instance'!

!MuSTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 20:05'!
instance
|sub|
super initialize.
instance:=self new.
self subclasses do:[:aSubClass|
	instance addPartial: aSubClass instance.
].
instance initialize.
^instance! !

!MuSTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 20:05'!
partials
^ self instance partials! !

!MuSTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 20:16'!
htmlCanvas
|a|
a:=Smalltalk at:#WAHtmlCanvas ifAbsent:[^nil].
^ a builder! !

!MuSTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 20:17'!
render
| html |
html :=self htmlCanvas.
^ self renderContentOn:html


! !

!MuSTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 20:12'!
renderContentOn:html
self subclassResponsibility! !
